//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39D3992203A6.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39D3992203A6.cm

//## begin module%39D3992203A6.cp preserve=no
//## end module%39D3992203A6.cp

//## Module: XspecDataIO%39D3992203A6; Package body
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/DataFactory/XspecDataIO.cxx

//## begin module%39D3992203A6.additionalIncludes preserve=no
//## end module%39D3992203A6.additionalIncludes

//## begin module%39D3992203A6.includes preserve=yes
//## end module%39D3992203A6.includes

// SpectralData
#include <XSModel/Data/SpectralData.h>
// XspecDataIO
#include <XSModel/DataFactory/XspecDataIO.h>


//## begin module%39D3992203A6.declarations preserve=no
//## end module%39D3992203A6.declarations

//## begin module%39D3992203A6.additionalDeclarations preserve=yes
#include <iostream>
#ifdef INXSPEC
#include "XSstreams.h"
#define _ERRSTREAM tcerr
#else
#define _ERRSTREAM std::cerr
#endif
//## end module%39D3992203A6.additionalDeclarations


// Class XspecDataIO::CannotOpen 

XspecDataIO::CannotOpen::CannotOpen()
  //## begin CannotOpen::CannotOpen%39A3F4C501B0_const.initialization preserve=yes
  : YellowAlert()
  //## end CannotOpen::CannotOpen%39A3F4C501B0_const.initialization
{
  //## begin XspecDataIO::CannotOpen::CannotOpen%39A3F4C501B0_const.body preserve=yes
  //## end XspecDataIO::CannotOpen::CannotOpen%39A3F4C501B0_const.body
}

XspecDataIO::CannotOpen::CannotOpen (const string& msg)
  //## begin XspecDataIO::CannotOpen::CannotOpen%39A3F4F102A5.hasinit preserve=yes
  : YellowAlert(" cannot open file named: ")
  //## end XspecDataIO::CannotOpen::CannotOpen%39A3F4F102A5.hasinit
  //## begin XspecDataIO::CannotOpen::CannotOpen%39A3F4F102A5.initialization preserve=yes
  //## end XspecDataIO::CannotOpen::CannotOpen%39A3F4F102A5.initialization
{
  //## begin XspecDataIO::CannotOpen::CannotOpen%39A3F4F102A5.body preserve=yes
  _ERRSTREAM << msg << std::endl;
  //## end XspecDataIO::CannotOpen::CannotOpen%39A3F4F102A5.body
}


// Class XspecDataIO::RequiredDataNotPresent 

XspecDataIO::RequiredDataNotPresent::RequiredDataNotPresent (const string& diag)
  //## begin XspecDataIO::RequiredDataNotPresent::RequiredDataNotPresent%3A2D32FD002C.hasinit preserve=yes
  : YellowAlert(string(" data file missing required entries: "))
  //## end XspecDataIO::RequiredDataNotPresent::RequiredDataNotPresent%3A2D32FD002C.hasinit
  //## begin XspecDataIO::RequiredDataNotPresent::RequiredDataNotPresent%3A2D32FD002C.initialization preserve=yes
  //## end XspecDataIO::RequiredDataNotPresent::RequiredDataNotPresent%3A2D32FD002C.initialization
{
  //## begin XspecDataIO::RequiredDataNotPresent::RequiredDataNotPresent%3A2D32FD002C.body preserve=yes
  _ERRSTREAM << diag << std::endl;
  //## end XspecDataIO::RequiredDataNotPresent::RequiredDataNotPresent%3A2D32FD002C.body
}


// Class XspecDataIO::SingleSpectrumOnly 

XspecDataIO::SingleSpectrumOnly::SingleSpectrumOnly (const string& diag)
  //## begin XspecDataIO::SingleSpectrumOnly::SingleSpectrumOnly%3A02D81200BF.hasinit preserve=yes
  : YellowAlert(string(" multiple sources requested from file containing single source"))
  //## end XspecDataIO::SingleSpectrumOnly::SingleSpectrumOnly%3A02D81200BF.hasinit
  //## begin XspecDataIO::SingleSpectrumOnly::SingleSpectrumOnly%3A02D81200BF.initialization preserve=yes
  //## end XspecDataIO::SingleSpectrumOnly::SingleSpectrumOnly%3A02D81200BF.initialization
{
  //## begin XspecDataIO::SingleSpectrumOnly::SingleSpectrumOnly%3A02D81200BF.body preserve=yes
  _ERRSTREAM << diag << std::endl;
  //## end XspecDataIO::SingleSpectrumOnly::SingleSpectrumOnly%3A02D81200BF.body
}


// Class XspecDataIO::UnspecifiedSpectrumNumber 

XspecDataIO::UnspecifiedSpectrumNumber::UnspecifiedSpectrumNumber (const string& diag)
  //## begin XspecDataIO::UnspecifiedSpectrumNumber::UnspecifiedSpectrumNumber%3A02D89102CA.hasinit preserve=yes
   : YellowAlert(string(" multiple source file needs spectrum number specified - File: ") )
  //## end XspecDataIO::UnspecifiedSpectrumNumber::UnspecifiedSpectrumNumber%3A02D89102CA.hasinit
  //## begin XspecDataIO::UnspecifiedSpectrumNumber::UnspecifiedSpectrumNumber%3A02D89102CA.initialization preserve=yes
  //## end XspecDataIO::UnspecifiedSpectrumNumber::UnspecifiedSpectrumNumber%3A02D89102CA.initialization
{
  //## begin XspecDataIO::UnspecifiedSpectrumNumber::UnspecifiedSpectrumNumber%3A02D89102CA.body preserve=yes
  _ERRSTREAM << diag << std::endl;
  //## end XspecDataIO::UnspecifiedSpectrumNumber::UnspecifiedSpectrumNumber%3A02D89102CA.body
}


// Class XspecDataIO::CatchAllIO 

XspecDataIO::CatchAllIO::CatchAllIO (const string& msg)
  //## begin XspecDataIO::CatchAllIO::CatchAllIO%3EA40AD80010.hasinit preserve=yes
  : YellowAlert(string(" IO error while:\n"))
  //## end XspecDataIO::CatchAllIO::CatchAllIO%3EA40AD80010.hasinit
  //## begin XspecDataIO::CatchAllIO::CatchAllIO%3EA40AD80010.initialization preserve=yes
  //## end XspecDataIO::CatchAllIO::CatchAllIO%3EA40AD80010.initialization
{
  //## begin XspecDataIO::CatchAllIO::CatchAllIO%3EA40AD80010.body preserve=yes
  _ERRSTREAM <<"  "<< msg << std::endl;
  //## end XspecDataIO::CatchAllIO::CatchAllIO%3EA40AD80010.body
}


// Class XspecDataIO 

XspecDataIO::XspecDataIO()
  //## begin XspecDataIO::XspecDataIO%39A3E113002F_const.initialization preserve=yes
  //## end XspecDataIO::XspecDataIO%39A3E113002F_const.initialization
{
  //## begin XspecDataIO::XspecDataIO%39A3E113002F_const.body preserve=yes
  //## end XspecDataIO::XspecDataIO%39A3E113002F_const.body
}


//## begin module%39D3992203A6.epilog preserve=yes
XspecDataIO::~XspecDataIO() {}
//## end module%39D3992203A6.epilog
